package org.ssssssss.example;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
//import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import org.ssssssss.example.mdjf.common.Constant;

import java.util.concurrent.ScheduledThreadPoolExecutor;


@SpringBootApplication
//@MapperScan(basePackages = {"com.huahai.demo.mapper.dao"})
//@ComponentScan(basePackages = "org.**")
@Configuration
@EnableTransactionManagement
@EnableScheduling       //支持@Schedule配置
//@EnableSwagger2	// 配置swagger 文档
public class MagicAPIExampleApplication {

	/**
	 * 设置定时任务的并发执行，设置线程池大小。
	 * 不设置的话所有的定时任务是串行执行的，这是Spring限制
	 * @return
	 */
	@Bean
	public ScheduledThreadPoolExecutor scheduledExecutorService(){
		return new ScheduledThreadPoolExecutor(Constant.SCHEDULED_THREAD_POOL);
	}

	public static void main(String[] args) {
		SpringApplication.run(MagicAPIExampleApplication.class, args);
	}
}

