package org.ssssssss.example.datacheck.bean;

import java.io.Serializable;

/**
 * 交互JSON数据封装
 * @Title:	JsonResult.java
 * @Description:	TODO
 * @author:	hwang
 * @date:	2020年6月9日
 * @version: V1.0
 */
public class JsonResult implements Serializable{
	private static final long serialVersionUID = 1L;
	private int code;//0:代表成功;1或其他值代表处理失败
	private Object data;//接收返回的数据
	private String msg;//定义提示信息

	public static final int SUCCESS=0;
	public static final int ERROR=500;


	public JsonResult(){
		this.code=SUCCESS;
	}

	public JsonResult(int state, Throwable e){
		this.code=state;
		data=null;
		msg=e.getMessage();
	}

	public JsonResult(int state, Object data, String message) {
		this.code = state;
		this.data = data;
		this.msg = message;
	}
	public JsonResult(Throwable e){
		code=ERROR;
		data=null;
		msg="服务内部异常:"+e.getMessage();
	}
	public JsonResult(Object data){
		code=SUCCESS;
		this.data=data;
		msg="操作成功!";
	}

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public Object getData() {
		return data;
	}

	public void setData(Object data) {
		this.data = data;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	@Override
	public String toString() {
		return "JsonResult [code=" + code + ", data=" + data + ", msg=" + msg + "]";
	}

}







