/**
 *
 */
package org.ssssssss.example.datacheck.controller;


import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.PropertySource;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;
import org.ssssssss.example.datacheck.bean.JsonResult;
import org.ssssssss.example.datacheck.service.DataCheckService;
import org.ssssssss.example.mdjf.common.Constant;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@CrossOrigin		//跨域支持
@RestController
@RequestMapping(value = "/mdjf/api/datacheck")
@PropertySource(value = "serviceConfig.yml", encoding = "UTF-8") // 加载配置文件

//@ApiIgnore			//接口不想在界面展示，隐藏
public class DataCheckController extends BaseController {

	private static final Logger LOGGER = LoggerFactory.getLogger(DataCheckController.class);

	@Autowired
	private DataCheckService dataCheckService;

	@Scheduled(cron = "${all_crontask_time}")
	@RequestMapping(value = "/runCrondTaskAll", method = RequestMethod.GET)
	public void dataCheckScheduledAll()  {
		dataCheckService.dataCheckScheduled("all");
		LOGGER.info("{} ： {} ms", Constant.SERVICE_NAME, "all 调度任务执行结束！");
	}

	@Scheduled(cron = "${first_crontask_time}")
	@RequestMapping(value = "/runCrondTaskFirst", method = RequestMethod.GET)
	public void dataCheckScheduledFirst()  {
		dataCheckService.dataCheckScheduled("first");
		LOGGER.info("{} ： {} ms", Constant.SERVICE_NAME, "first 调度任务执行结束！");
	}

	@RequestMapping(value = "/runTaskByTaskId", method = RequestMethod.GET)
	public void runTaskByTaskId(@RequestParam(value = "taskId", required = true) String taskId){
		dataCheckService.dataCheckScheduled(taskId);
		LOGGER.info("{} ：taskId: {} ms", Constant.SERVICE_NAME, "taskId");
	}

	@RequestMapping(value = "/checkDBConnect", method = RequestMethod.GET)
	public JsonResult checkDBConnect(@RequestParam(value = "id", required = true) String dbid){
		return dataCheckService.checkDBConnect(dbid);
	}





}



