/**
 *
 */
package org.ssssssss.example.datacheck.controller;


import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.PropertySource;
import org.springframework.core.io.InputStreamResource;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;
import org.ssssssss.example.datacheck.bean.JsonResult;
import org.ssssssss.example.datacheck.service.DataCheckService;
import org.ssssssss.example.datacheck.service.DataExportService;
import org.ssssssss.example.mdjf.common.Constant;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@CrossOrigin		//跨域支持
@RestController
@RequestMapping(value = "/mdjf/api/export")
@PropertySource(value = "serviceConfig.yml", encoding = "UTF-8") // 加载配置文件

//@ApiIgnore			//接口不想在界面展示，隐藏
public class DataExportController extends BaseController {

	private static final Logger LOGGER = LoggerFactory.getLogger(DataExportController.class);

	@Autowired
	private DataExportService dataExportService;


	@RequestMapping(value = "/mdjftotal", method = RequestMethod.GET)
	public ResponseEntity<InputStreamResource> mdjftotal(HttpServletResponse response, @RequestParam(value = "startTime",required = false) String startTime, @RequestParam(value = "endTime",required = false) String endTime) throws IOException {
		return dataExportService.mdjftotal(startTime,endTime,response);
	}

	@RequestMapping(value = "/zdrtotal", method = RequestMethod.GET)
	public void zdrtotal(HttpServletResponse response,
						 @RequestParam(value = "startTime",required = false) String startTime,
						 @RequestParam(value = "endTime",required = false) String endTime) throws IOException {
		dataExportService.zdrtotal(startTime,endTime,response);
	}


	@RequestMapping(value = "/yjzxList", method = RequestMethod.GET)
	public void yjzxList(HttpServletResponse response,
						 @RequestParam(value = "idno",required = false) String idno,
						 @RequestParam(value = "jsdwmc",required = false) String jsdwmc,
						 @RequestParam(value = "name",required = false) String name,
						 @RequestParam(value = "rwlx",required = false) String rwlx,
						 @RequestParam(value = "rwmc",required = false) String rwmc,
						 @RequestParam(value = "sqdwmc",required = false) String sqdwmc,
						 @RequestParam(value = "yjsjEnd",required = false) String yjsjEnd,
						 @RequestParam(value = "yjsjStart",required = false) String yjsjStart,
						 @RequestParam(value = "yjzt",required = false) String yjzt,
						 @RequestParam(value = "zrmj",required = false) String zrmj

						 ) throws IOException {
//		JSONObject obj = JSONObject.parseObject(jsonString);
//		String idno = obj.getString("idno");
//		String jsdwmc = obj.getString("jsdwmc");
//		String name = obj.getString("name");
//		String rwlx = obj.getString("rwlx");
//		String rwmc = obj.getString("rwmc");
//		String sqdwmc = obj.getString("sqdwmc");
//		String yjsjEnd = obj.getString("yjsjEnd");
//		String yjsjStart = obj.getString("yjsjStart");
//		String yjzt = obj.getString("yjzt");
//		String zrmj = obj.getString("zrmj");



		dataExportService.yjzxList(response,idno,jsdwmc,name,rwlx,rwmc,sqdwmc,yjsjEnd,yjsjStart,yjzt,zrmj);
	}



	@RequestMapping(value = "/mdjfList", method = RequestMethod.GET)
	public void mdjfList(HttpServletResponse response,
						 @RequestParam(value = "bjlx",required = false) String bjlx,
						 @RequestParam(value = "bldw",required = false) String bldw,
						 @RequestParam(value = "blzrr",required = false) String blzrr,
						 @RequestParam(value = "dataSource",required = false) String dataSource,
						 @RequestParam(value = "eventAddress",required = false) String eventAddress,
						 @RequestParam(value = "eventDataEnd",required = false) String eventDataEnd,
						 @RequestParam(value = "eventDataStart",required = false) String eventDataStart,
						 @RequestParam(value = "eventId",required = false) String eventId,
						 @RequestParam(value = "eventName",required = false) String eventName,
						 @RequestParam(value = "eventType",required = false) String eventType,
						 @RequestParam(value = "idno",required = false) String idno,
						 @RequestParam(value = "isZdgz",required = false) String isZdgz,
						 @RequestParam(value = "partyType",required = false) String partyType,
						 @RequestParam(value = "sjrs",required = false) String sjrs,
						 @RequestParam(value = "slsjEnd",required = false) String slsjEnd,
						 @RequestParam(value = "slsjStart",required = false) String slsjStart
						 ) throws IOException {
//		JSONObject obj = JSONObject.parseObject(jsonString);
//		String bjlx = obj.getString("bjlx");
//		String bldw = obj.getString("bldw");
//		String blzrr = obj.getString("blzrr");
//		String dataSource = obj.getString("dataSource");
//		String eventAddress = obj.getString("eventAddress");
//		String eventDataEnd = obj.getString("eventDataEnd");
//		String eventDataStart = obj.getString("eventDataStart");
//		String eventId = obj.getString("eventId");
//		String eventName = obj.getString("eventName");
//		String eventType = obj.getString("eventType");
//		String idno = obj.getString("idno");
//		String isZdgz = obj.getString("isZdgz");
//		String partyType = obj.getString("partyType");
//		String sjrs = obj.getString("sjrs");
//		String slsjEnd = obj.getString("slsjEnd");
//		String slsjStart = obj.getString("slsjStart");


		dataExportService.mdjfList(response,bjlx,bldw,blzrr,dataSource,eventAddress,eventDataEnd,eventDataStart,eventId,eventName,eventType,idno,isZdgz,partyType,sjrs,slsjEnd,slsjStart);
	}



	@RequestMapping(value = "/zdrList", method = RequestMethod.GET)
	public void zdrList(HttpServletRequest request, HttpServletResponse response,
						@RequestBody(required = false) String requestBody,
						@RequestParam(value = "edfx",required = false) String edfx,
						@RequestParam(value = "gksjStart",required = false) String gksjStart,
						@RequestParam(value = "gksjEnd",required = false) String gksjEnd,
						@RequestParam(value = "gkztStr",required = false) String gkzt,
						@RequestParam(value = "rybq",required = false) String rybq,
						@RequestParam(value = "rylb",required = false) String rylb,
						@RequestParam(value = "ryzt",required = false) String ryzt,
						@RequestParam(value = "sdfx",required = false) String sdfx,
						@RequestParam(value = "tsyj",required = false) String tsyj,
						@RequestParam(value = "fengxian",required = false) String fengxian,
						@RequestParam(value = "zrbm",required = false) String zrbm,
						@RequestParam(value = "zrdw",required = false) String zrdw,
						@RequestParam(value = "zrr",required = false) String zrr

						) throws IOException {


//		// 获取所有参数名
//		System.err.println(JSONObject.toJSONString(request.getParameterMap()));
//		System.err.println(11111);
//
//		System.err.println(JSONObject.toJSONString(requestBody));



//		JSONObject obj = JSONObject.parseObject(jsonString);
//		String edfx = obj.getString("edfx");
//		String gksjStart = obj.getString("gksjStart");
//		String gksjEnd = obj.getString("gksjEnd");
//		String gkztStr = obj.getString("gkztStr");
//		String rybq = obj.getString("rybq");
//		String rylb = obj.getString("rylb");
//		String ryzt = obj.getString("ryzt");
//		String sdfx = obj.getString("sdfx");
//		String tsyj = obj.getString("tsyj");
//		String fengxian = obj.getString("fengxian");
//		String zrbm = obj.getString("zrbm");
//		String zrdw = obj.getString("zrdw");
//		String zrr = obj.getString("zrr");

		dataExportService.zdrList(response,edfx,gksjStart,gksjEnd,gkzt,rybq,rylb,ryzt,sdfx,tsyj,fengxian,zrbm,zrdw,zrr);
	}




}



