/**
 *
 */
package org.ssssssss.example.datacheck.dao;


import com.baomidou.dynamic.datasource.annotation.DS;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;
import org.ssssssss.example.mdjf.common.Constant;

import java.util.Date;
import java.util.List;
import java.util.Map;


@Repository
@DS("mdjf")
public class MDJFDao {
	private static final Logger LOGGER = LoggerFactory.getLogger(MDJFDao.class);

	@Autowired
	private JdbcTemplate mdjfJdbcTemplate;

	public List<Map<String, Object>> findFirstRunTask() {
		String sql = "SELECT dbs.DBNAME,dbs.DBTYPE,dbs.URL,dbs.PWD,dbs.USERNAME," +
				"tasks.ID,tasks.DBID,tasks.TBCNAME,tasks.TBENAME,tasks.CJTYPE," +
				"tasks.CHECKFIELDS,tasks.STATUS " +
				"FROM MDJF_CHECK_TABLES tasks LEFT JOIN  MDJF_DBINFOS dbs" +
				" on tasks.DBID = dbs.id " +
				" where tasks.STATUS ='1'  and tasks.LASTCHECKSTATUS is null ";  //待首次运行
		List<Map<String, Object>> result =	mdjfJdbcTemplate.queryForList(sql);
		LOGGER.info("{} 数据查询成功： {} ", Constant.SERVICE_NAME, sql);
		return result;
	}

	public List<Map<String, Object>> findAllRunTask() {
		String sql = "SELECT dbs.DBNAME,dbs.DBTYPE,dbs.URL,dbs.PWD,dbs.USERNAME," +
				"tasks.ID,tasks.DBID,tasks.TBCNAME,tasks.TBENAME,tasks.CJTYPE," +
				"tasks.CHECKFIELDS,tasks.STATUS " +
				"FROM MDJF_CHECK_TABLES tasks LEFT JOIN  MDJF_DBINFOS dbs" +
				" on tasks.DBID = dbs.id " +
				" where tasks.STATUS ='1' ";
		List<Map<String, Object>> result =	mdjfJdbcTemplate.queryForList(sql);
		LOGGER.info("{} 数据查询成功： {} ", Constant.SERVICE_NAME, sql);
		return result;
	}

	public List<Map<String, Object>> findTaskById(String tableTaskId) {
		String sql = "SELECT dbs.DBNAME,dbs.DBTYPE,dbs.URL,dbs.PWD,dbs.USERNAME," +
				"tasks.ID,tasks.DBID,tasks.TBCNAME,tasks.TBENAME,tasks.CJTYPE," +
				"tasks.CHECKFIELDS,tasks.STATUS " +
				"FROM MDJF_CHECK_TABLES tasks LEFT JOIN  MDJF_DBINFOS dbs" +
				" on tasks.DBID = dbs.id " +
				" where tasks.STATUS ='1'  and tasks.ID = ?";
		List<Map<String, Object>> result =	mdjfJdbcTemplate.queryForList(sql,tableTaskId);
		LOGGER.info("{} 数据查询成功： {} ", Constant.SERVICE_NAME, sql);
		return result;
	}

	public void saveCheckTaskLog(String DBID,String DBNAME,String taskId,String TBCNAME,String TBENAME,String CHECKROWS,String VALIDROWS,String WANZHENG,String CHECKSTATUS,String CHECKSTATUSMSG){
		System.out.println(DBID+","+DBNAME+","+taskId+","+TBCNAME+","+TBENAME+","+CHECKROWS+","+VALIDROWS+","+WANZHENG+","+CHECKSTATUS+","+CHECKSTATUSMSG);
		String sql = "insert into MDJF_CHECK_TASK_LOG (DBID,DBNAME,TBTASKID,TBCNAME,TBENAME,CHECKROWS,VALIDROWS,WANZHENG,CHECKSTATUS,CHECKSTATUSMSG) " +
				" values (?,?,?,?,?,?,?,?,?,?)";
		int successNum = mdjfJdbcTemplate.update(sql,DBID,DBNAME,taskId,TBCNAME,TBENAME,CHECKROWS,VALIDROWS,WANZHENG,CHECKSTATUS,CHECKSTATUSMSG);
		LOGGER.info("{} MDJF_CHECK_TASK_LOG--数据写入成功： {} ", Constant.SERVICE_NAME, successNum);
	}

	public void updateCheckTableTask(Date LASTCHECKTIME, String LASTCHECKSTATUS, String LASTCHECKSTATUSMSG, String LASTCHECKROWS, String LASTVALIDROWS, String LASTWANZHENG,String tableTaskID) {
		String sql = " update MDJF_CHECK_TABLES set LASTCHECKTIME = ?,LASTCHECKSTATUS = ?,LASTCHECKSTATUSMSG = ?,LASTCHECKROWS = ?,LASTVALIDROWS = ?,LASTWANZHENG = ?  where ID = ?  ";
		int successNum = mdjfJdbcTemplate.update(sql,LASTCHECKTIME,LASTCHECKSTATUS,LASTCHECKSTATUSMSG,LASTCHECKROWS,LASTVALIDROWS,LASTWANZHENG,tableTaskID);
		LOGGER.info("{} MDJF_CHECK_TABLES--id:{},更新成功： {} ", Constant.SERVICE_NAME,tableTaskID, successNum);

	}

	public Map<String, Object> findDBInfoById(String DBId) {
		String sql = "select DBNAME,DBTYPE,URL,USERNAME,PWD from MDJF_DBINFOS where ID = ?";
		Map<String, Object> result =	mdjfJdbcTemplate.queryForMap(sql,DBId);
		LOGGER.info("{} 数据查询成功： {} ", Constant.SERVICE_NAME, sql);
		return result;
	}


	public void updateDBConnectResult(String SELECTSTATUS,String SELECTSTATUSMSG,String DBID) {
		String sql = " update MDJF_DBINFOS set SELECTSTATUS = ?,SELECTSTATUSMSG = ? where ID = ?  ";
		int successNum = mdjfJdbcTemplate.update(sql,SELECTSTATUS,SELECTSTATUSMSG,DBID);
		LOGGER.info("{} MDJF_DBINFOS--id:{},更新连接测试结果： {} ", Constant.SERVICE_NAME,DBID, successNum);

	}

}
