package org.ssssssss.example.datacheck.service;

import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.core.io.InputStreamResource;
import org.springframework.http.ResponseEntity;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.ssssssss.example.datacheck.bean.CheckErrorTypeEnum;
import org.ssssssss.example.datacheck.bean.DBTypeEnum;
import org.ssssssss.example.datacheck.bean.JsonResult;
import org.ssssssss.example.datacheck.common.CustomDateSource;
import org.ssssssss.example.datacheck.common.DateUtils;
import org.ssssssss.example.datacheck.common.ExcelExportUtil;
import org.ssssssss.example.datacheck.common.ExcelExportUtilBlob;
import org.ssssssss.example.datacheck.dao.DataExportMapper;
import org.ssssssss.example.datacheck.dao.MDJFDao;
import org.ssssssss.example.mdjf.common.CommonUtil;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service
// 加载配置文件
@PropertySource(value = "serviceConfig.yml", encoding = "UTF-8") // 加载配置文件
public class DataExportService {

  private static final Logger LOGGER = LoggerFactory.getLogger(DataExportService.class);


  @Autowired
  private DataExportMapper dataExportMapper;

  public ResponseEntity<InputStreamResource> mdjftotal(String startTime, String endTime, HttpServletResponse response) throws IOException {
    List<Map<String,Object>> result = dataExportMapper.mdjftotal(startTime,endTime);
    return ExcelExportUtilBlob.exportToExcel(response,result,"矛盾纠纷统计报表导出","导出结果");
//    ExcelExportUtil.exportToExcel(response,result,"矛盾纠纷统计报表导出","导出结果");
  }

  public void zdrtotal(String startTime, String endTime, HttpServletResponse response) throws IOException {
    List<Map<String,Object>> result = dataExportMapper.zdrtotal(startTime,endTime);
    ExcelExportUtil.exportToExcel(response,result,"重点人报表导出","导出结果");
  }

  public void yjzxList(HttpServletResponse response, String idno, String jsdwmc, String name, String rwlx, String rwmc, String sqdwmc, String yjsjEnd, String yjsjStart, String yjzt, String zrmj) throws IOException {
    List<Map<String,Object>> result = dataExportMapper.yjzxList(idno,jsdwmc,name,rwlx,rwmc,sqdwmc,yjsjEnd,yjsjStart,yjzt,zrmj);
    ExcelExportUtil.exportToExcel(response,result,"预警信息导出","导出结果");
  }

  public void mdjfList(HttpServletResponse response, String bjlx, String bldw, String blzrr, String dataSource, String eventAddress, String eventDataEnd, String eventDataStart, String eventId, String eventName, String eventType, String idno, String isZdgz, String partyType, String sjrs, String slsjEnd, String slsjStart) throws IOException {
    List<Map<String,Object>> result = dataExportMapper.mdjfList(bjlx,bldw,blzrr,dataSource,eventAddress,eventDataEnd,eventDataStart,eventId,eventName,eventType,idno,isZdgz,partyType,sjrs,slsjEnd,slsjStart);
    ExcelExportUtil.exportToExcel(response,result,"矛盾纠纷列表导出","导出结果");
  }

  public void zdrList(HttpServletResponse response, String edfx, String gksjStart, String gksjEnd, String gkzt, String rybq, String rylb, String ryzt, String sdfx, String tsyj, String fengxian, String zrbm, String zrdw, String zrr) throws IOException {
    List<Map<String,Object>> result = dataExportMapper.zdrList(edfx,gksjStart,gksjEnd,gkzt,rybq,rylb,ryzt,sdfx,tsyj,fengxian,zrbm,zrdw,zrr);
    ExcelExportUtil.exportToExcel(response,result,"重点人列表导出","导出结果");

  }
}
