package org.ssssssss.example.mdjf;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.util.JSONPObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Service;
import org.ssssssss.example.mdjf.common.CommonUtil;
import org.ssssssss.example.mdjf.common.FieldCheckUtil;
import org.ssssssss.example.mdjf.domain.CheckMethodEnum;
import org.ssssssss.example.mdjf.domain.XZQHEnum;
import org.ssssssss.magicapi.modules.db.model.PageResult;

import java.text.DecimalFormat;
import java.util.*;
import java.util.stream.Collectors;

@Service
// 加载配置文件
@PropertySource(value = "serviceConfig.yml", encoding = "UTF-8")
public class UtilService {
    private static final Logger LOGGER = LoggerFactory.getLogger(UtilService.class);

    @Value("${testPath}")
    private String testPath;
    private DecimalFormat df = new DecimalFormat("#.00");

    /**
     * 矛盾纠纷列表计算完整度
     * @param dbList
     * @param wzruleList
     * @return
     */
    public PageResult processMdjfListWanZheng(PageResult dbList,ArrayList<Map<String,String>> wzruleList){

        System.out.println(dbList.getClass());
        System.out.println(JSONObject.toJSONString(dbList));
        System.out.println(wzruleList.getClass());
        System.out.println(JSONObject.toJSONString(wzruleList));
        System.out.println(testPath);

        List<Map<String,Object>> pageList = dbList.getList();       //传过来的数据List
        if(pageList == null){
            return dbList;
        }

        for(Map<String,Object> tmpInfo: pageList){  //便利List 的每条数据
            double i = 0;
            for(Map<String,String> tmpFieldRule : wzruleList){    //对每个数据，定制的规则进行 完整度监测Field
                if(FieldCheckUtil.FieldCheck(tmpInfo.get(tmpFieldRule.get("FIELD")),tmpFieldRule.get("RULE"))){
                    //规则校验通过
                    i++;
                }
            }

            String wanzheng = df.format(i/wzruleList.size() * 100)+"%";

            System.out.println("监测："+wzruleList.size());
            System.out.println("监测通过："+i);
            System.out.println("wanZheng："+wanzheng);

            tmpInfo.put("WANZHENGDU",wanzheng);
        }

        return dbList;
    }


    public void testCrod(){

        System.out.println("testCrod");

    }

    /**
     * 重点人报表统计计算
     * @param dbList
     * @return
     */
    public JSONArray processZdrTotal(ArrayList<Map<String,String>> dbList){
        Map<String,List<String>> resultMap = new HashMap<>();


        for(Map<String,String> tmpData : dbList){           //遍历所有结果
            String FENJU = tmpData.get("FENJU");

            for(XZQHEnum tmpxzqh :XZQHEnum.values()){   //遍历行政区划
                if(tmpxzqh.getName().equals(FENJU)){
                    List<String> rylbtmpList = new ArrayList<>(Arrays.asList(tmpData.get("PERSON_CLASS").split(",")));
                    if(resultMap.containsKey(FENJU)){   //原resultMap 存在此单位
                        resultMap.get(FENJU).addAll(rylbtmpList);
                    }else{
                        resultMap.put(FENJU,rylbtmpList);
                    }
                    break;  //如果命中一个分局，就调出比对
                }
            }
        }


        System.err.println(JSONObject.toJSONString(resultMap));

        JSONArray result = new JSONArray();

        for(Map.Entry<String,List<String>> tmpxzqhinfo: resultMap.entrySet()){
            String xzqh = tmpxzqhinfo.getKey();

            Map<String, Long> xzqhrylx = tmpxzqhinfo.getValue().stream()
                    .collect(Collectors.groupingBy(tmpxzqhRylx -> tmpxzqhRylx, Collectors.counting()));

            JSONObject resutlXzqhData =  JSONObject.parseObject(JSONObject.toJSONString(xzqhrylx));
            resutlXzqhData.put("xzqh",xzqh);
            result.add(resutlXzqhData);
        }

//        System.err.println(result);

        return result;

    }



    /**
     * 重点人标签统计
     * @param dbList
     * @return
     */
    public Map<String, Long> processZdrCountByField(ArrayList<Map<String,String>> dbList,String field){
        List<String> resultList = new ArrayList<>();


        for(Map<String,String> tmpData : dbList){           //遍历所有结果
            List<String> rylbtmpList = new ArrayList<>(Arrays.asList(tmpData.get(field).split(",")));
            resultList.addAll(rylbtmpList);
        }


        Map<String, Long> rylxgroup = resultList.stream()
                    .collect(Collectors.groupingBy(tmpRylx -> tmpRylx, Collectors.counting()));


        return rylxgroup;

    }


}
