package org.ssssssss.example.mdjf.common;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


public class IDCardNumUtils {
	
	/** 中国公民身份证号码最小长度。 */
    public static final int CHINA_ID_MIN_LENGTH = 15;

    /** 中国公民身份证号码最大长度。 */
    public static final int CHINA_ID_MAX_LENGTH = 18;
    //未知
    public static final int USER_GENDER_UNKNOW = 1;
    //男
    public static final int USER_GENDER_MALE = 2;
    //女
    public static final int USER_GENDER_FEMALE = 3;
    /** 省、直辖市代码表 */
    public static final String cityCode[] = {
            "11", "12", "13", "14", "15", "21", "22", "23", "31", "32", "33", "34", "35", "36", "37", "41",
            "42", "43", "44", "45", "46", "50", "51", "52", "53", "54", "61", "62", "63", "64", "65", "71",
            "81", "82", "91"
    };

    /** 每位加权因子 */
    public static final int power[] = {
            7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2
    };

    /** 第18位校检码 */
    public static final String verifyCode[] = {
            "1", "0", "X", "9", "8", "7", "6", "5", "4", "3", "2"
    };
    /** 最低年限 */
    public static final int MIN = 1930;
    public static Map<String, String> provinceCodes = new HashMap<String, String>();
//   public static Map<String, String> cityCodes = new HashMap<String, String>();
    /** 台湾身份首字母对应数字 */
    public static Map<String, Integer> twFirstCode = new HashMap<String, Integer>();
    /** 香港身份首字母对应数字 */
    public static Map<String, Integer> hkFirstCode = new HashMap<String, Integer>();
    static {
		provinceCodes.put("11", "北京");
		provinceCodes.put("12", "天津");
		provinceCodes.put("13", "河北");
		provinceCodes.put("14", "山西");
		provinceCodes.put("15", "内蒙古");
		provinceCodes.put("21", "辽宁");
		provinceCodes.put("22", "吉林");
		provinceCodes.put("23", "黑龙江");
		provinceCodes.put("31", "上海");
		provinceCodes.put("32", "江苏");
		provinceCodes.put("33", "浙江");
		provinceCodes.put("34", "安徽");
		provinceCodes.put("35", "福建");
		provinceCodes.put("36", "江西");
		provinceCodes.put("37", "山东");
		provinceCodes.put("41", "河南");
		provinceCodes.put("42", "湖北");
		provinceCodes.put("43", "湖南");
		provinceCodes.put("44", "广东");
		provinceCodes.put("45", "广西");
		provinceCodes.put("46", "海南");
		provinceCodes.put("50", "重庆");
		provinceCodes.put("51", "四川");
		provinceCodes.put("52", "贵州");
		provinceCodes.put("53", "云南");
		provinceCodes.put("54", "西藏");
		provinceCodes.put("61", "陕西");
		provinceCodes.put("62", "甘肃");
		provinceCodes.put("63", "青海");
		provinceCodes.put("64", "宁夏");
		provinceCodes.put("65", "新疆");
		provinceCodes.put("71", "台湾");
		provinceCodes.put("81", "香港");
		provinceCodes.put("82", "澳门");
		provinceCodes.put("91", "国外");
//		 cityCodes.put("1101", "北京，北京市");
//		 cityCodes.put("1102", "北京，北京市");
//		 cityCodes.put("1201", "天津，天津市");
//		 cityCodes.put("1202", "天津，天津市");
//		 cityCodes.put("1301", "河北，石家庄市");
//		 cityCodes.put("1302", "河北，唐山市");
//		 cityCodes.put("1303", "河北，秦皇岛市");
//		 cityCodes.put("1304", "河北，邯郸市");
//		 cityCodes.put("1305", "河北，邢台市");
//		 cityCodes.put("1306", "河北，保定市");
//		 cityCodes.put("1307", "河北，张家口市");
//		 cityCodes.put("1308", "河北，承德市");
//		 cityCodes.put("1309", "河北，沧州市");
//		 cityCodes.put("1310", "河北，廊坊市");
//		 cityCodes.put("1311", "河北，衡水市");
//		 cityCodes.put("1401", "山西，太原市");
//		 cityCodes.put("1402", "山西，大同市");
//		 cityCodes.put("1403", "山西，阳泉市");
//		 cityCodes.put("1404", "山西，长治市");
//		 cityCodes.put("1405", "山西，晋城市");
//		 cityCodes.put("1406", "山西，朔州市");
//		 cityCodes.put("1407", "山西，晋中市");
//		 cityCodes.put("1408", "山西，运城市");
//		 cityCodes.put("1409", "山西，忻州市");
//		 cityCodes.put("1410", "山西，临汾市");
//		 cityCodes.put("1411", "山西，吕梁市");
//		 cityCodes.put("1421", "山西，雁北地区");
//		 cityCodes.put("1422", "山西，忻州地区");
//		 cityCodes.put("1423", "山西，吕梁地区");
//		 cityCodes.put("1424", "山西，晋中地区");
//		 cityCodes.put("1426", "山西，临汾地区");
//		 cityCodes.put("1427", "山西，运城地区");
//		 cityCodes.put("1490", "山西，古交市");
//		 cityCodes.put("1501", "内蒙古，呼和浩特市");
//		 cityCodes.put("1502", "内蒙古，包头市");
//		 cityCodes.put("1503", "内蒙古，乌海市");
//		 cityCodes.put("1504", "内蒙古，赤峰市");
//		 cityCodes.put("1505", "内蒙古，通辽市");
//		 cityCodes.put("1506", "内蒙古，鄂尔多斯市");
//		 cityCodes.put("1507", "内蒙古，呼伦贝尔市");
//		 cityCodes.put("1508", "内蒙古，巴彦淖尔市");
//		 cityCodes.put("1509", "内蒙古，乌兰察布市");
//		 cityCodes.put("1521", "内蒙古，呼伦贝尔盟");
//		 cityCodes.put("1522", "内蒙古，兴安盟");
//		 cityCodes.put("1523", "内蒙古，哲里木盟");
//		 cityCodes.put("1524", "内蒙古，昭乌达盟");
//		 cityCodes.put("1525", "内蒙古，锡林郭勒盟");
//		 cityCodes.put("1526", "内蒙古，乌兰察布盟");
//		 cityCodes.put("1527", "内蒙古，伊克昭盟");
//		 cityCodes.put("1528", "内蒙古，巴彦淖尔盟");
//		 cityCodes.put("1529", "内蒙古，阿拉善盟");
//		 cityCodes.put("2101", "辽宁，沈阳市");
//		 cityCodes.put("2102", "辽宁，大连市");
//		 cityCodes.put("2103", "辽宁，鞍山市");
//		 cityCodes.put("2104", "辽宁，抚顺市");
//		 cityCodes.put("2105", "辽宁，本溪市");
//		 cityCodes.put("2106", "辽宁，丹东市");
//		 cityCodes.put("2107", "辽宁，锦州市");
//		 cityCodes.put("2108", "辽宁，营口市");
//		 cityCodes.put("2109", "辽宁，阜新市");
//		 cityCodes.put("2110", "辽宁，辽阳市");
//		 cityCodes.put("2111", "辽宁，盘锦市");
//		 cityCodes.put("2112", "辽宁，铁岭市");
//		 cityCodes.put("2113", "辽宁，朝阳市");
//		 cityCodes.put("2114", "辽宁，葫芦岛市");
//		 cityCodes.put("2121", "辽宁，铁岭市");
//		 cityCodes.put("2122", "辽宁，朝阳市");
//		 cityCodes.put("2190", "辽宁，瓦房、海城、锦西市");
//		 cityCodes.put("2201", "吉林，长春市");
//		 cityCodes.put("2202", "吉林，吉林市");
//		 cityCodes.put("2203", "吉林，四平市");
//		 cityCodes.put("2204", "吉林，辽源市");
//		 cityCodes.put("2205", "吉林，通化市");
//		 cityCodes.put("2206", "吉林，白山市");
//		 cityCodes.put("2207", "吉林，松原市");
//		 cityCodes.put("2208", "吉林，白城市");
//		 cityCodes.put("2221", "吉林，四平市、辽源市、怀德县、梨树县、伊通满族自治县、东丰县、双辽县");
//		 cityCodes.put("2222", "吉林，通化、浑江市");
//		 cityCodes.put("2223", "吉林，白城地区");
//		 cityCodes.put("2224", "吉林，延边朝鲜自治州");
//		 cityCodes.put("2301", "黑龙江，哈尔滨市");
//		 cityCodes.put("2302", "黑龙江，齐齐哈尔市");
//		 cityCodes.put("2303", "黑龙江，鸡西市");
//		 cityCodes.put("2304", "黑龙江，鹤岗市");
//		 cityCodes.put("2305", "黑龙江，双鸭山市");
//		 cityCodes.put("2306", "黑龙江，大庆市");
//		 cityCodes.put("2307", "黑龙江，伊春市");
//		 cityCodes.put("2308", "黑龙江，佳木斯市");
//		 cityCodes.put("2309", "黑龙江，七台河市");
//		 cityCodes.put("2310", "黑龙江，牡丹江市");
//		 cityCodes.put("2311", "黑龙江，黑河市");
//		 cityCodes.put("2312", "黑龙江，绥化市");
//		 cityCodes.put("2321", "黑龙江，松花江地区");
//		 cityCodes.put("2323", "黑龙江，绥化地区");
//		 cityCodes.put("2324", "黑龙江，佳木斯地区");
//		 cityCodes.put("2325", "黑龙江，牡丹江地区");
//		 cityCodes.put("2326", "黑龙江，黑河地区");
//		 cityCodes.put("2327", "黑龙江，大兴安岭地区");
//		 cityCodes.put("2390", "黑龙江，绥芬河市");
//		 cityCodes.put("3101", "上海，上海市");
//		 cityCodes.put("3102", "上海，上海市");
//		 cityCodes.put("3201", "江苏，南京市");
//		 cityCodes.put("3202", "江苏，无锡市");
//		 cityCodes.put("3203", "江苏，徐州市");
//		 cityCodes.put("3204", "江苏，常州市");
//		 cityCodes.put("3205", "江苏，苏州市");
//		 cityCodes.put("3206", "江苏，南通市");
//		 cityCodes.put("3207", "江苏，连云港市");
//		 cityCodes.put("3208", "江苏，淮安市");
//		 cityCodes.put("3209", "江苏，盐城市");
//		 cityCodes.put("3210", "江苏，扬州市");
//		 cityCodes.put("3211", "江苏，镇江市");
//		 cityCodes.put("3212", "江苏，泰州市");
//		 cityCodes.put("3213", "江苏，宿迁市");
//		 cityCodes.put("3301", "浙江，杭州市");
//		 cityCodes.put("3302", "浙江，宁波市");
//		 cityCodes.put("3303", "浙江，温州市");
//		 cityCodes.put("3304", "浙江，嘉兴市");
//		 cityCodes.put("3305", "浙江，湖州市");
//		 cityCodes.put("3306", "浙江，绍兴市");
//		 cityCodes.put("3307", "浙江，金华市");
//		 cityCodes.put("3308", "浙江，衢州市");
//		 cityCodes.put("3309", "浙江，舟山市");
//		 cityCodes.put("3310", "浙江，台州市");
//		 cityCodes.put("3311", "浙江，丽水市");
//		 cityCodes.put("3311", "浙江，丽水市");
//		 cityCodes.put("3325", "浙江，丽水地区");
//		 cityCodes.put("3326", "浙江，台州地区");
//		 cityCodes.put("3327", "浙江，舟山地区");
//		 cityCodes.put("3390", "浙江，余姚、海宁、兰溪、瑞安、萧山、江山、义乌、东阳、慈溪、奉化、诸暨市");
//		 cityCodes.put("3401", "安徽，合肥市");
//		 cityCodes.put("3402", "安徽，芜湖市");
//		 cityCodes.put("3403", "安徽，蚌埠市");
//		 cityCodes.put("3404", "安徽，淮南市");
//		 cityCodes.put("3405", "安徽，马鞍山市");
//		 cityCodes.put("3406", "安徽，淮北市");
//		 cityCodes.put("3407", "安徽，铜陵市");
//		 cityCodes.put("3408", "安徽，安庆市");
//		 cityCodes.put("3410", "安徽，黄山市");
//		 cityCodes.put("3411", "安徽，滁州市");
//		 cityCodes.put("3412", "安徽，阜阳市");
//		 cityCodes.put("3413", "安徽，宿州市");
//		 cityCodes.put("3414", "安徽，巢湖市");
//		 cityCodes.put("3415", "安徽，六安市");
//		 cityCodes.put("3416", "安徽，亳州市");
//		 cityCodes.put("3417", "安徽，池州市");
//		 cityCodes.put("3418", "安徽，宣城市");
//		 cityCodes.put("3421", "安徽，阜阳地区");
//		 cityCodes.put("3422", "安徽，宿县地区");
//		 cityCodes.put("3423", "安徽，滁县地区");
//		 cityCodes.put("3424", "安徽，六安地区");
//		 cityCodes.put("3425", "安徽，宣城地区");
//		 cityCodes.put("3426", "安徽，巢湖地区");
//		 cityCodes.put("3427", "安徽，徽州地区");
//		 cityCodes.put("3428", "安徽，安庆地区");
//		 cityCodes.put("3429", "安徽，池州地区");
//		 cityCodes.put("3501", "福建，福州市");
//		 cityCodes.put("3502", "福建，厦门市");
//		 cityCodes.put("3503", "福建，莆田市");
//		 cityCodes.put("3504", "福建，三明市");
//		 cityCodes.put("3505", "福建，泉州市");
//		 cityCodes.put("3506", "福建，漳州市");
//		 cityCodes.put("3507", "福建，南平市");
//		 cityCodes.put("3508", "福建，龙岩市");
//		 cityCodes.put("3509", "福建，宁德市");
//		 cityCodes.put("3521", "福建，南平地区");
//		 cityCodes.put("3522", "福建，宁德地区");
//		 cityCodes.put("3526", "福建，龙岩地区");
//		 cityCodes.put("3527", "福建，三明市");
//		 cityCodes.put("3590", "福建，永安、石狮市");
//		 cityCodes.put("3601", "江西，南昌市");
//		 cityCodes.put("3602", "江西，景德镇市");
//		 cityCodes.put("3603", "江西，萍乡市");
//		 cityCodes.put("3604", "江西，九江市");
//		 cityCodes.put("3605", "江西，新余市");
//		 cityCodes.put("3606", "江西，鹰潭市");
//		 cityCodes.put("3607", "江西，赣州市");
//		 cityCodes.put("3608", "江西，吉安市");
//		 cityCodes.put("3609", "江西，宜春市");
//		 cityCodes.put("3610", "江西，抚州市");
//		 cityCodes.put("3611", "江西，上饶市");
//		 cityCodes.put("3621", "江西，赣州地区");
//		 cityCodes.put("3622", "江西，宜春地区");
//		 cityCodes.put("3623", "江西，上饶地区");
//		 cityCodes.put("3624", "江西，吉安地区");
//		 cityCodes.put("3625", "江西，抚州地区");
//		 cityCodes.put("3626", "江西，九江地区");
//		 cityCodes.put("3701", "山东，济南市");
//		 cityCodes.put("3702", "山东，青岛市");
//		 cityCodes.put("3703", "山东，淄博市");
//		 cityCodes.put("3704", "山东，枣庄市");
//		 cityCodes.put("3705", "山东，东营市");
//		 cityCodes.put("3706", "山东，烟台市");
//		 cityCodes.put("3707", "山东，潍坊市");
//		 cityCodes.put("3708", "山东，济宁市");
//		 cityCodes.put("3709", "山东，泰安市");
//		 cityCodes.put("3710", "山东，威海市");
//		 cityCodes.put("3711", "山东，日照市");
//		 cityCodes.put("3712", "山东，莱芜市");
//		 cityCodes.put("3713", "山东，临沂市");
//		 cityCodes.put("3714", "山东，德州市");
//		 cityCodes.put("3715", "山东，聊城市");
//		 cityCodes.put("3716", "山东，滨州市");
//		 cityCodes.put("3717", "山东，菏泽市");
//		 cityCodes.put("3721", "山东，烟台地区");
//		 cityCodes.put("3722", "山东，潍坊地区");
//		 cityCodes.put("3723", "山东，滨州地区");
//		 cityCodes.put("3724", "山东，德州地区");
//		 cityCodes.put("3725", "山东，聊城市");
//		 cityCodes.put("3726", "山东，泰安地区");
//		 cityCodes.put("3727", "山东，济宁地区");
//		 cityCodes.put("3728", "山东，临沂地区");
//		 cityCodes.put("3729", "山东，菏泽地区");
//		 cityCodes.put("3790", "山东，青州、龙口、曲阜、莱芜、新泰、胶州、诸城、莱阳、莱州、滕州、文登、荣城市");
//		 cityCodes.put("4101", "河南，郑州市");
//		 cityCodes.put("4102", "河南，开封市");
//		 cityCodes.put("4103", "河南，洛阳市");
//		 cityCodes.put("4104", "河南，平顶山市");
//		 cityCodes.put("4105", "河南，安阳市");
//		 cityCodes.put("4106", "河南，鹤壁市");
//		 cityCodes.put("4107", "河南，新乡市");
//		 cityCodes.put("4108", "河南，焦作市");
//		 cityCodes.put("4109", "河南，濮阳市");
//		 cityCodes.put("4110", "河南，许昌市");
//		 cityCodes.put("4111", "河南，漯河市");
//		 cityCodes.put("4112", "河南，三门峡市");
//		 cityCodes.put("4113", "河南，南阳市");
//		 cityCodes.put("4114", "河南，商丘市");
//		 cityCodes.put("4115", "河南，信阳市");
//		 cityCodes.put("4116", "河南，周口市");
//		 cityCodes.put("4117", "河南，驻马店市");
//		 cityCodes.put("4123", "河南，商丘地区");
//		 cityCodes.put("4124", "河南，开封地区");
//		 cityCodes.put("4125", "河南，三门峡市");
//		 cityCodes.put("4126", "河南，许昌市");
//		 cityCodes.put("4127", "河南，周口地区");
//		 cityCodes.put("4128", "河南，驻马店地区");
//		 cityCodes.put("4129", "河南，南阳地区");
//		 cityCodes.put("4130", "河南，信阳地区");
//		 cityCodes.put("4190", "河南，义马、汝州、济源、禹州、卫辉、辉县市");
//		 cityCodes.put("4201", "湖北，武汉市");
//		 cityCodes.put("4202", "湖北，黄石市");
//		 cityCodes.put("4203", "湖北，十堰市");
//		 cityCodes.put("4204", "湖北，沙市");
//		 cityCodes.put("4205", "湖北，宜昌市");
//		 cityCodes.put("4206", "湖北，襄樊市");
//		 cityCodes.put("4207", "湖北，鄂州市");
//		 cityCodes.put("4208", "湖北，荆门市");
//		 cityCodes.put("4209", "湖北，孝感市");
//		 cityCodes.put("4210", "湖北，荆州市");
//		 cityCodes.put("4211", "湖北，黄冈市");
//		 cityCodes.put("4212", "湖北，咸宁市");
//		 cityCodes.put("4213", "湖北，随州市");
//		 cityCodes.put("4221", "湖北，黄冈地区");
//		 cityCodes.put("4222", "湖北，孝感地区");
//		 cityCodes.put("4223", "湖北，咸宁地区");
//		 cityCodes.put("4224", "湖北，荆州地区");
//		 cityCodes.put("4225", "湖北，随州地区");
//		 cityCodes.put("4226", "湖北，郧阳地区");
//		 cityCodes.put("4227", "湖北，宜昌地区");
//		 cityCodes.put("4228", "湖北，恩施土家族苗族自治州");
//		 cityCodes.put("4229", "湖北，神农架林区");
//		 cityCodes.put("4290", "湖北，随州市、仙桃市、潜江市、天门市、神农架林区");
//		 cityCodes.put("4301", "湖南，长沙市");
//		 cityCodes.put("4302", "湖南，株洲市");
//		 cityCodes.put("4303", "湖南，湘潭市");
//		 cityCodes.put("4304", "湖南，衡阳市");
//		 cityCodes.put("4305", "湖南，邵阳市");
//		 cityCodes.put("4306", "湖南，岳阳市");
//		 cityCodes.put("4307", "湖南，常德市");
//		 cityCodes.put("4308", "湖南，张家界市");
//		 cityCodes.put("4309", "湖南，益阳市");
//		 cityCodes.put("4310", "湖南，郴州市");
//		 cityCodes.put("4311", "湖南，永州市");
//		 cityCodes.put("4312", "湖南，怀化市");
//		 cityCodes.put("4313", "湖南，娄底市");
//		 cityCodes.put("4321", "湖南，湘潭地区");
//		 cityCodes.put("4322", "湖南，岳阳地区");
//		 cityCodes.put("4323", "湖南，益阳地区");
//		 cityCodes.put("4324", "湖南，常德地区");
//		 cityCodes.put("4325", "湖南，娄底地区");
//		 cityCodes.put("4326", "湖南，邵阳地区");
//		 cityCodes.put("4327", "湖南，衡阳地区");
//		 cityCodes.put("4328", "湖南，郴州地区");
//		 cityCodes.put("4329", "湖南，零陵地区");
//		 cityCodes.put("4330", "湖南，怀化地区");
//		 cityCodes.put("4331", "湖南，湘西土家族苗族自治州");
//		 cityCodes.put("4390", "湖南，汨罗、醴陵、湘乡、耒阳、津市市");
//		 cityCodes.put("4401", "广东，广州市");
//		 cityCodes.put("4402", "广东，韶关市");
//		 cityCodes.put("4403", "广东，深圳市");
//		 cityCodes.put("4404", "广东，珠海市");
//		 cityCodes.put("4405", "广东，汕头市");
//		 cityCodes.put("4406", "广东，佛山市");
//		 cityCodes.put("4407", "广东，江门市");
//		 cityCodes.put("4408", "广东，湛江市");
//		 cityCodes.put("4409", "广东，茂名市");
//		 cityCodes.put("4412", "广东，肇庆市");
//		 cityCodes.put("4413", "广东，惠州市");
//		 cityCodes.put("4414", "广东，梅州市");
//		 cityCodes.put("4415", "广东，汕尾市");
//		 cityCodes.put("4416", "广东，河源市");
//		 cityCodes.put("4417", "广东，阳江市");
//		 cityCodes.put("4418", "广东，清远市");
//		 cityCodes.put("4419", "广东，东莞市");
//		 cityCodes.put("4420", "广东，中山市");
//		 cityCodes.put("4425", "广东，惠州市、东莞市、连平县、河源县、博罗县、东莞县、惠东县、龙川县、陆丰县、海丰县、惠阳县、紫金县、和平县");
//		 cityCodes.put("4426", "广东，始兴、南雄、仁化、乐昌、清远、翁源、连山壮族瑶族自治、连南瑶族自治、乳源瑶族自治县");
//		 cityCodes.put("4427", "广东，佛山市");
//		 cityCodes.put("4428", "广东，高要、四会、广宁、怀集、封开、德庆、云浮、新兴、郁南、罗定县");
//		 cityCodes.put("4429", "广东，湛江市");
//		 cityCodes.put("4451", "广东，潮州市");
//		 cityCodes.put("4452", "广东，揭阳市");
//		 cityCodes.put("4453", "广东，云浮市");
//		 cityCodes.put("4501", "广西，南宁市");
//		 cityCodes.put("4502", "广西，柳州市");
//		 cityCodes.put("4503", "广西，桂林市");
//		 cityCodes.put("4504", "广西，梧州市");
//		 cityCodes.put("4505", "广西，北海市");
//		 cityCodes.put("4506", "广西，访城港市");
//		 cityCodes.put("4507", "广西，钦州市");
//		 cityCodes.put("4508", "广西，贵港市");
//		 cityCodes.put("4509", "广西，玉林市");
//		 cityCodes.put("4510", "广西，百色市");
//		 cityCodes.put("4511", "广西，贺州市");
//		 cityCodes.put("4512", "广西，河池市");
//		 cityCodes.put("4513", "广西，来宾市");
//		 cityCodes.put("4514", "广西，崇左市");
//		 cityCodes.put("4521", "广西，南宁地区");
//		 cityCodes.put("4522", "广西，柳州地区");
//		 cityCodes.put("4523", "广西，桂林地区");
//		 cityCodes.put("4524", "广西，贺州地区");
//		 cityCodes.put("4525", "广西，玉林地区");
//		 cityCodes.put("4526", "广西，百色地区");
//		 cityCodes.put("4527", "广西，河池地区");
//		 cityCodes.put("4528", "广西，钦州地区");
//		 cityCodes.put("4600", "海南，直辖县级行政单位");
//		 cityCodes.put("4601", "海南，海口市");
//		 cityCodes.put("4602", "海南，海口市");
//		 cityCodes.put("4603", "海南，三亚市");
//		 cityCodes.put("4690", "海南，直辖县级行政单位");
//		 cityCodes.put("5001", "重庆，重庆市");
//		 cityCodes.put("5001", "重庆，重庆市");
//		 cityCodes.put("5002", "重庆，重庆市");
//		 cityCodes.put("5003", "重庆，江津、合川、永川、南川市");
//		 cityCodes.put("5101", "四川，成都市");
//		 cityCodes.put("5103", "四川，自贡市");
//		 cityCodes.put("5104", "四川，攀枝花市");
//		 cityCodes.put("5105", "四川，泸州市");
//		 cityCodes.put("5106", "四川，德阳市");
//		 cityCodes.put("5107", "四川，绵阳市");
//		 cityCodes.put("5108", "四川，广元市");
//		 cityCodes.put("5109", "四川，遂宁市");
//		 cityCodes.put("5110", "四川，内江市");
//		 cityCodes.put("5111", "四川，乐山市");
//		 cityCodes.put("5112", "四川，万县市");
//		 cityCodes.put("5113", "四川，南充市");
//		 cityCodes.put("5114", "四川，眉山市");
//		 cityCodes.put("5115", "四川，宜宾市");
//		 cityCodes.put("5116", "四川，广安市");
//		 cityCodes.put("5117", "四川，达州市");
//		 cityCodes.put("5118", "四川，雅安市");
//		 cityCodes.put("5119", "四川，巴中市");
//		 cityCodes.put("5120", "四川，资阳市");
//		 cityCodes.put("5122", "四川，万县地区");
//		 cityCodes.put("5123", "四川，涪陵地区");
//		 cityCodes.put("5125", "四川，宜宾地区");
//		 cityCodes.put("5129", "四川，南充地区");
//		 cityCodes.put("5130", "四川，达川地区");
//		 cityCodes.put("5131", "四川，雅安地区");
//		 cityCodes.put("5132", "四川，阿坝藏族羌族自治州");
//		 cityCodes.put("5133", "四川，甘孜藏族自治州");
//		 cityCodes.put("5134", "四川，凉山彝族自治州");
//		 cityCodes.put("5135", "四川，黔江地区");
//		 cityCodes.put("5136", "四川，广安市");
//		 cityCodes.put("5137", "四川，巴中地区");
//		 cityCodes.put("5138", "四川，眉山地区");
//		 cityCodes.put("5139", "四川，资阳地区");
//		 cityCodes.put("5190", "四川，广汉、江油、都江宴、峨眉山市");
//		 cityCodes.put("5201", "贵州，贵阳市");
//		 cityCodes.put("5202", "贵州，六盘水市");
//		 cityCodes.put("5203", "贵州，遵义市");
//		 cityCodes.put("5204", "贵州，安顺市");
//		 cityCodes.put("5221", "贵州，遵义地区");
//		 cityCodes.put("5222", "贵州，铜仁地区");
//		 cityCodes.put("5223", "贵州，黔西南布依族苗族自治州");
//		 cityCodes.put("5224", "贵州，毕节地区");
//		 cityCodes.put("5225", "贵州，安顺地区");
//		 cityCodes.put("5226", "贵州，黔东南苗族侗族自治州");
//		 cityCodes.put("5227", "贵州，黔南布依族苗族自治州");
//		 cityCodes.put("5301", "云南，昆明市");
//		 cityCodes.put("5303", "云南，曲靖市");
//		 cityCodes.put("5304", "云南，玉溪市");
//		 cityCodes.put("5305", "云南，保山市");
//		 cityCodes.put("5306", "云南，昭通市");
//		 cityCodes.put("5307", "云南，丽江市");
//		 cityCodes.put("5308", "云南，思茅市");
//		 cityCodes.put("5309", "云南，临沧市");
//		 cityCodes.put("5321", "云南，昭通地区");
//		 cityCodes.put("5322", "云南，曲靖地区");
//		 cityCodes.put("5323", "云南，楚雄彝族自治州");
//		 cityCodes.put("5324", "云南，玉溪地区");
//		 cityCodes.put("5325", "云南，红河哈尼族彝族自治州");
//		 cityCodes.put("5326", "云南，文山壮族苗族自治州");
//		 cityCodes.put("5327", "云南，思茅地区");
//		 cityCodes.put("5328", "云南，西双版纳傣族自治州");
//		 cityCodes.put("5329", "云南，大理白族自治州");
//		 cityCodes.put("5331", "云南，德宏傣族景颇族自治州");
//		 cityCodes.put("5332", "云南，丽江地区");
//		 cityCodes.put("5333", "云南，怒江僳僳族自治州");
//		 cityCodes.put("5334", "云南，迪庆藏族自治州");
//		 cityCodes.put("5335", "云南，临沧地区");
//		 cityCodes.put("5401", "西藏，拉萨市");
//		 cityCodes.put("5421", "西藏，昌都地区");
//		 cityCodes.put("5422", "西藏，山南地区");
//		 cityCodes.put("5423", "西藏，日喀则地区");
//		 cityCodes.put("5424", "西藏，那曲地区");
//		 cityCodes.put("5425", "西藏，阿里地区");
//		 cityCodes.put("5426", "西藏，林芝地区");
//		 cityCodes.put("5427", "西藏，江孜地区");
//		 cityCodes.put("6101", "陕西，西安市");
//		 cityCodes.put("6102", "陕西，铜川市");
//		 cityCodes.put("6103", "陕西，宝鸡市");
//		 cityCodes.put("6104", "陕西，咸阳市");
//		 cityCodes.put("6105", "陕西，渭南市");
//		 cityCodes.put("6106", "陕西，延安市");
//		 cityCodes.put("6107", "陕西，汉中市");
//		 cityCodes.put("6108", "陕西，榆林市");
//		 cityCodes.put("6109", "陕西，安康市");
//		 cityCodes.put("6110", "陕西，商洛市");
//		 cityCodes.put("6121", "陕西，渭南地区");
//		 cityCodes.put("6122", "陕西，咸阳地区");
//		 cityCodes.put("6123", "陕西，汉中地区");
//		 cityCodes.put("6124", "陕西，安康地区");
//		 cityCodes.put("6125", "陕西，商洛地区");
//		 cityCodes.put("6126", "陕西，延安地区");
//		 cityCodes.put("6127", "陕西，榆林地区");
//		 cityCodes.put("6201", "甘肃，兰州市");
//		 cityCodes.put("6202", "甘肃，嘉峪关市");
//		 cityCodes.put("6203", "甘肃，金昌市");
//		 cityCodes.put("6204", "甘肃，白银市");
//		 cityCodes.put("6205", "甘肃，天水市");
//		 cityCodes.put("6206", "甘肃，武威市");
//		 cityCodes.put("6207", "甘肃，张掖市");
//		 cityCodes.put("6208", "甘肃，平凉市");
//		 cityCodes.put("6209", "甘肃，酒泉市");
//		 cityCodes.put("6210", "甘肃，庆阳市");
//		 cityCodes.put("6211", "甘肃，定西市");
//		 cityCodes.put("6212", "甘肃，陇南市");
//		 cityCodes.put("6221", "甘肃，酒泉地区");
//		 cityCodes.put("6222", "甘肃，张掖地区");
//		 cityCodes.put("6223", "甘肃，武威地区");
//		 cityCodes.put("6224", "甘肃，定西地区");
//		 cityCodes.put("6226", "甘肃，陇南地区");
//		 cityCodes.put("6227", "甘肃，平凉地区");
//		 cityCodes.put("6228", "甘肃，庆阳地区");
//		 cityCodes.put("6229", "甘肃，临夏回族自治州");
//		 cityCodes.put("6230", "甘肃，甘南藏族自治州");
//		 cityCodes.put("6301", "青海，西宁市");
//		 cityCodes.put("6321", "青海，海东地区");
//		 cityCodes.put("6322", "青海，海北藏族自治州");
//		 cityCodes.put("6323", "青海，黄南藏族自治州");
//		 cityCodes.put("6325", "青海，海南藏族自治州");
//		 cityCodes.put("6326", "青海，果洛藏族自治州");
//		 cityCodes.put("6327", "青海，玉树藏族自治州");
//		 cityCodes.put("6328", "青海，海西蒙古族藏族自治州");
//		 cityCodes.put("6401", "宁夏，银川市");
//		 cityCodes.put("6402", "宁夏，石嘴山市");
//		 cityCodes.put("6403", "宁夏，吴忠市");
//		 cityCodes.put("6404", "宁夏，固原市");
//		 cityCodes.put("6405", "宁夏，中卫市");
//		 cityCodes.put("6421", "宁夏，吴忠市");
//		 cityCodes.put("6422", "宁夏，固原市");
//		 cityCodes.put("6501", "新疆，乌鲁木齐市");
//		 cityCodes.put("6502", "新疆，克拉玛依市");
//		 cityCodes.put("6521", "新疆，吐鲁番地区");
//		 cityCodes.put("6522", "新疆，哈密地区");
//		 cityCodes.put("6523", "新疆，昌吉回族自治州");
//		 cityCodes.put("6524", "新疆，伊犁哈萨克自治州");
//		 cityCodes.put("6525", "新疆，塔城地区");
//		 cityCodes.put("6526", "新疆，阿勒泰地区");
//		 cityCodes.put("6527", "新疆，博尔塔拉蒙古自治州");
//		 cityCodes.put("6528", "新疆，巴音郭楞蒙古自治州");
//		 cityCodes.put("6529", "新疆，阿克苏地区");
//		 cityCodes.put("6530", "新疆，克孜勒苏柯尔克孜自治州");
//		 cityCodes.put("6531", "新疆，喀什地区");
//		 cityCodes.put("6532", "新疆，和田地区");
//		 cityCodes.put("6540", "新疆，伊犁哈萨克自治州");
//		 cityCodes.put("6541", "新疆，伊犁地区");
//		 cityCodes.put("6542", "新疆，塔城地区");
//		 cityCodes.put("6543", "新疆，阿勒泰地区");
//		 cityCodes.put("6590", "新疆，石河子市");
//		 cityCodes.put("7100", "台湾，台湾");
//		 cityCodes.put("8100", "香港，香港");
//		 cityCodes.put("8200", "澳门，澳门");
//		 cityCodes.put("9100", "国外，国外");
        twFirstCode.put("A", 10);
        twFirstCode.put("B", 11);
        twFirstCode.put("C", 12);
        twFirstCode.put("D", 13);
        twFirstCode.put("E", 14);
        twFirstCode.put("F", 15);
        twFirstCode.put("G", 16);
        twFirstCode.put("H", 17);
        twFirstCode.put("J", 18);
        twFirstCode.put("K", 19);
        twFirstCode.put("L", 20);
        twFirstCode.put("M", 21);
        twFirstCode.put("N", 22);
        twFirstCode.put("P", 23);
        twFirstCode.put("Q", 24);
        twFirstCode.put("R", 25);
        twFirstCode.put("S", 26);
        twFirstCode.put("T", 27);
        twFirstCode.put("U", 28);
        twFirstCode.put("V", 29);
        twFirstCode.put("X", 30);
        twFirstCode.put("Y", 31);
        twFirstCode.put("W", 32);
        twFirstCode.put("Z", 33);
        twFirstCode.put("I", 34);
        twFirstCode.put("O", 35);
        hkFirstCode.put("A", 1);
        hkFirstCode.put("B", 2);
        hkFirstCode.put("C", 3);
        hkFirstCode.put("R", 18);
        hkFirstCode.put("U", 21);
        hkFirstCode.put("Z", 26);
        hkFirstCode.put("X", 24);
        hkFirstCode.put("W", 23);
        hkFirstCode.put("O", 15);
        hkFirstCode.put("N", 14);
    }

    /**
     * 将15位身份证号码转换为18位
     * 
     * @param IDCardNum
     *            15位身份编码
     * @return 18位身份编码
     */
    public static String conver15CardTo18(String IDCardNum) {
        String IDCardNum18 = "";
        if (IDCardNum.length() != CHINA_ID_MIN_LENGTH) {
            return null;
        }
        if (isNum(IDCardNum)) {
            // 获取出生年月日
            String birthday = IDCardNum.substring(6, 12);
            Date birthDate = null;
            try {
                birthDate = new SimpleDateFormat("yyMMdd").parse(birthday);
            } catch (ParseException e) {
                e.printStackTrace();
            }
            Calendar cal = Calendar.getInstance();
            if (birthDate != null)
                cal.setTime(birthDate);
            // 获取出生年(完全表现形式,如：2010)
            String sYear = String.valueOf(cal.get(Calendar.YEAR));
            IDCardNum18 = IDCardNum.substring(0, 6) + sYear + IDCardNum.substring(8);
            // 转换字符数组
            char[] cArr = IDCardNum18.toCharArray();
            if (cArr != null) {
                int[] iCard = converCharToInt(cArr);
                int iSum17 = getPowerSum(iCard);
                // 获取校验位
                String sVal = getCheckCode18(iSum17);
                if (sVal.length() > 0) {
                    IDCardNum18 += sVal;
                } else {
                    return null;
                }
            }
        } else {
            return null;
        }
        return IDCardNum18;
    }

    /**
     * 验证身份证是否合法
     */
    public static boolean validateCard(String IDCardNum) {
        String card = IDCardNum.trim();
        if (validateIdCard18(card)) {
            return true;
        }
        if (validateIdCard15(card)) {
            return true;
        }
        String[] cardval = validateIdCard10(card);
        if (cardval != null) {
            if (cardval[2].equals("true")) {
                return true;
            }
        }
        return false;
    }

    /**
     * 验证18位身份编码是否合法
     * 
     * @param IDCardNum 身份编码
     * @return 是否合法
     */
    public static boolean validateIdCard18(String IDCardNum) {
        boolean bTrue = false;
        if (IDCardNum.length() == CHINA_ID_MAX_LENGTH) {
            // 前17位
            String code17 = IDCardNum.substring(0, 17);
            // 第18位
            String code18 = IDCardNum.substring(17, CHINA_ID_MAX_LENGTH);
            if (isNum(code17)) {
                char[] cArr = code17.toCharArray();
                if (cArr != null) {
                    int[] iCard = converCharToInt(cArr);
                    int iSum17 = getPowerSum(iCard);
                    // 获取校验位
                    String val = getCheckCode18(iSum17);
                    if (val.length() > 0) {
                        if (val.equalsIgnoreCase(code18)) {
                            bTrue = true;
                        }
                    }
                }
            }
        }
        return bTrue;
    }

    /**
     * 验证15位身份编码是否合法
     * 
     * @param IDCardNum
     *            身份编码
     * @return 是否合法
     */
    public static boolean validateIdCard15(String IDCardNum) {
        if (IDCardNum.length() != CHINA_ID_MIN_LENGTH) {
            return false;
        }
        if (isNum(IDCardNum)) {
            String proCode = IDCardNum.substring(0, 2);
            if (provinceCodes.get(proCode) == null) {
                return false;
            }
            String birthCode = IDCardNum.substring(6, 12);
            Date birthDate = null;
            try {
                birthDate = new SimpleDateFormat("yy").parse(birthCode.substring(0, 2));
            } catch (ParseException e) {
                e.printStackTrace();
            }
            Calendar cal = Calendar.getInstance();
            if (birthDate != null)
                cal.setTime(birthDate);
            if (!valiDate(cal.get(Calendar.YEAR), Integer.valueOf(birthCode.substring(2, 4)),
                    Integer.valueOf(birthCode.substring(4, 6)))) {
                return false;
            }
        } else {
            return false;
        }
        return true;
    }

    /**
     * 验证10位身份编码是否合法
     * 
     * @param IDCardNum 身份编码
     * @return 身份证信息数组
     *         <p>
     *         [0] - 台湾、澳门、香港 [1] - 性别(男M,女F,未知N) [2] - 是否合法(合法true,不合法false)
     *         若不是身份证件号码则返回null
     *         </p>
     */
    public static String[] validateIdCard10(String IDCardNum) {
        String[] info = new String[3];
        String card = IDCardNum.replaceAll("[\\(|\\)]", "");
        if (card.length() != 8 && card.length() != 9 && IDCardNum.length() != 10) {
            return null;
        }
        if (IDCardNum.matches("^[a-zA-Z][0-9]{9}$")) { // 台湾
            info[0] = "台湾";
            System.out.println("11111");
            String char2 = IDCardNum.substring(1, 2);
            if (char2.equals("1")) {
                info[1] = "M";
                System.out.println("MMMMMMM");
            } else if (char2.equals("2")) {
                info[1] = "F";
                System.out.println("FFFFFFF");
            } else {
                info[1] = "N";
                info[2] = "false";
                System.out.println("NNNN");
                return info;
            }
            info[2] = validateTWCard(IDCardNum) ? "true" : "false";
        } else if (IDCardNum.matches("^[1|5|7][0-9]{6}\\(?[0-9A-Z]\\)?$")) { // 澳门
            info[0] = "澳门";
            info[1] = "N";
            // TODO
        } else if (IDCardNum.matches("^[A-Z]{1,2}[0-9]{6}\\(?[0-9A]\\)?$")) { // 香港
            info[0] = "香港";
            info[1] = "N";
            info[2] = validateHKCard(IDCardNum) ? "true" : "false";
        } else {
            return null;
        }
        return info;
    }

    /**
     * 验证台湾身份证号码
     * 
     * @param IDCardNum
     *            身份证号码
     * @return 验证码是否符合
     */
    public static boolean validateTWCard(String IDCardNum) {
        String start = IDCardNum.substring(0, 1);
        String mid = IDCardNum.substring(1, 9);
        String end = IDCardNum.substring(9, 10);
        Integer iStart = twFirstCode.get(start);
        Integer sum = iStart / 10 + (iStart % 10) * 9;
        char[] chars = mid.toCharArray();
        Integer iflag = 8;
        for (char c : chars) {
            sum = sum + Integer.valueOf(c + "") * iflag;
            iflag--;
        }
        return (sum % 10 == 0 ? 0 : (10 - sum % 10)) == Integer.valueOf(end) ? true : false;
    }

    /**
     * 验证香港身份证号码(存在Bug，部份特殊身份证无法检查)
     * <p>
     * 身份证前2位为英文字符，如果只出现一个英文字符则表示第一位是空格，对应数字58 前2位英文字符A-Z分别对应数字10-35
     * 最后一位校验码为0-9的数字加上字符"A"，"A"代表10
     * </p>
     * <p>
     * 将身份证号码全部转换为数字，分别对应乘9-1相加的总和，整除11则证件号码有效
     * </p>
     * 
     * @param IDCardNum 身份证号码
     * @return 验证码是否符合
     */
    public static boolean validateHKCard(String IDCardNum) {
        String card = IDCardNum.replaceAll("[\\(|\\)]", "");
        Integer sum = 0;
        if (card.length() == 9) {
            sum = (Integer.valueOf(card.substring(0, 1).toUpperCase().toCharArray()[0]) - 55) * 9
                    + (Integer.valueOf(card.substring(1, 2).toUpperCase().toCharArray()[0]) - 55) * 8;
            card = card.substring(1, 9);
        } else {
            sum = 522 + (Integer.valueOf(card.substring(0, 1).toUpperCase().toCharArray()[0]) - 55) * 8;
        }
        String mid = card.substring(1, 7);
        String end = card.substring(7, 8);
        char[] chars = mid.toCharArray();
        Integer iflag = 7;
        for (char c : chars) {
            sum = sum + Integer.valueOf(c + "") * iflag;
            iflag--;
        }
        if (end.toUpperCase().equals("A")) {
            sum = sum + 10;
        } else {
            sum = sum + Integer.valueOf(end);
        }
        return (sum % 11 == 0) ? true : false;
    }

    /**
     * 将字符数组转换成数字数组
     * 
     * @param ca
     *            字符数组
     * @return 数字数组
     */
    public static int[] converCharToInt(char[] ca) {
        int len = ca.length;
        int[] iArr = new int[len];
        try {
            for (int i = 0; i < len; i++) {
                iArr[i] = Integer.parseInt(String.valueOf(ca[i]));
            }
        } catch (NumberFormatException e) {
            e.printStackTrace();
        }
        return iArr;
    }

    /**
     * 将身份证的每位和对应位的加权因子相乘之后，再得到和值
     * 
     * @param iArr
     * @return 身份证编码。
     */
    public static int getPowerSum(int[] iArr) {
        int iSum = 0;
        if (power.length == iArr.length) {
            for (int i = 0; i < iArr.length; i++) {
                for (int j = 0; j < power.length; j++) {
                    if (i == j) {
                        iSum = iSum + iArr[i] * power[j];
                    }
                }
            }
        }
        return iSum;
    }

    /**
     * 将power和值与11取模获得余数进行校验码判断
     * 
     * @param iSum
     * @return 校验位
     */
    public static String getCheckCode18(int iSum) {
        String sCode = "";
        switch (iSum % 11) {
        case 10:
            sCode = "2";
            break;
        case 9:
            sCode = "3";
            break;
        case 8:
            sCode = "4";
            break;
        case 7:
            sCode = "5";
            break;
        case 6:
            sCode = "6";
            break;
        case 5:
            sCode = "7";
            break;
        case 4:
            sCode = "8";
            break;
        case 3:
            sCode = "9";
            break;
        case 2:
            sCode = "x";
            break;
        case 1:
            sCode = "0";
            break;
        case 0:
            sCode = "1";
            break;
        }
        return sCode;
    }

    /**
     * 根据身份编号获取年龄
     * 
     * @param IDCardNum
     *            身份编号
     * @return 年龄
     */
    public static int getAgeByIdCard(String IDCardNum) {
        int age = 0;
        if (IDCardNum.length() == CHINA_ID_MIN_LENGTH) {
            IDCardNum = conver15CardTo18(IDCardNum);
        }
        String year = IDCardNum.substring(6, 10);
        Calendar cal = Calendar.getInstance();
        int currYear = cal.get(Calendar.YEAR);
        age = currYear - Integer.valueOf(year);
        return age;
    }

    /**
     * 根据身份编号获取生日
     * 
     * @param IDCardNum 身份编号
     * @return 生日(yyyyMMdd)
     */
    public static String getBirthByIdCard(String IDCardNum) {
        Integer len = IDCardNum.length();
        if (len < CHINA_ID_MIN_LENGTH) {
            return null;
        } else if (len == CHINA_ID_MIN_LENGTH) {
            IDCardNum = conver15CardTo18(IDCardNum);
        }
        return IDCardNum.substring(6, 14);
    }

    /**
     * 根据身份编号获取生日年
     * 
     * @param IDCardNum 身份编号
     * @return 生日(yyyy)
     */
    public static Short getYearByIdCard(String IDCardNum) {
        Integer len = IDCardNum.length();
        if (len < CHINA_ID_MIN_LENGTH) {
            return null;
        } else if (len == CHINA_ID_MIN_LENGTH) {
            IDCardNum = conver15CardTo18(IDCardNum);
        }
        return Short.valueOf(IDCardNum.substring(6, 10));
    }

    /**
     * 根据身份编号获取生日月
     * 
     * @param IDCardNum
     *            身份编号
     * @return 生日(MM)
     */
    public static Short getMonthByIdCard(String IDCardNum) {
        Integer len = IDCardNum.length();
        if (len < CHINA_ID_MIN_LENGTH) {
            return null;
        } else if (len == CHINA_ID_MIN_LENGTH) {
            IDCardNum = conver15CardTo18(IDCardNum);
        }
        return Short.valueOf(IDCardNum.substring(10, 12));
    }

    /**
     * 根据身份编号获取生日天
     * 
     * @param IDCardNum
     *            身份编号
     * @return 生日(dd)
     */
    public static Short getDateByIdCard(String IDCardNum) {
        Integer len = IDCardNum.length();
        if (len < CHINA_ID_MIN_LENGTH) {
            return null;
        } else if (len == CHINA_ID_MIN_LENGTH) {
            IDCardNum = conver15CardTo18(IDCardNum);
        }
        return Short.valueOf(IDCardNum.substring(12, 14));
    }

    /**
     * 根据身份编号获取性别
     * 
     * @param IDCardNum 身份编号
     * @return 性别(M-男，F-女，N-未知)
     */
    public static int getGenderByIdCard(String IDCardNum) {
        int gender = IDCardNumUtils.USER_GENDER_UNKNOW;
        if (IDCardNum.length() == CHINA_ID_MIN_LENGTH) {
            IDCardNum = conver15CardTo18(IDCardNum);
        }
        String sCardNum = IDCardNum.substring(16, 17);
        if (Integer.parseInt(sCardNum) % 2 != 0) {
        	gender = IDCardNumUtils.USER_GENDER_MALE;
        } else {
        	gender = IDCardNumUtils.USER_GENDER_FEMALE;
        }
        return gender;
    }

//    /**
//     * 根据身份编号获取户籍份
//     * 
//     * @param IDCardNum 身份编码
//     * @return 级编码。
//     */
//    public static String getProvinceByIdCard(String IDCardNum) {
//        int len = IDCardNum.length();
//        String sProvince = null;
//        String sProvinNum = "";
//        if (len == CHINA_ID_MIN_LENGTH || len == CHINA_ID_MAX_LENGTH) {
//            sProvinNum = IDCardNum.substring(0, 4);
//        }
//        sProvince = cityCodes.get(sProvinNum);
//        return sProvince;
//    }
    
    /**
     * 根据身份编号获取户籍
     * 
     * @param IDCardNum 身份编码
     * @return 级编码。
     */
    public static String getProvinceByIDCardNum(String IDCardNum) {
        int len = IDCardNum.length();
        String province = null;
        String provinceNum = "";
        if (len == CHINA_ID_MIN_LENGTH || len == CHINA_ID_MAX_LENGTH) {
        	provinceNum = IDCardNum.substring(0, 2);
        }
        province = provinceCodes.get(provinceNum);
        return province;
    }
    
    /**
     * 数字验证
     * 
     * @param val
     * @return 提取的数字。
     */
    public static boolean isNum(String val) {
        return val == null || "".equals(val) ? false : val.matches("^[0-9]*$");
    }

    /**
     * 验证小于当前日期 是否有效
     * 
     * @param iYear
     *            待验证日期(年)
     * @param iMonth
     *            待验证日期(月 1-12)
     * @param iDate
     *            待验证日期(日)
     * @return 是否有效
     */
    public static boolean valiDate(int iYear, int iMonth, int iDate) {
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        int datePerMonth;
        if (iYear < MIN || iYear >= year) {
            return false;
        }
        if (iMonth < 1 || iMonth > 12) {
            return false;
        }
        switch (iMonth) {
        case 4:
        case 6:
        case 9:
        case 11:
            datePerMonth = 30;
            break;
        case 2:
            boolean dm = ((iYear % 4 == 0 && iYear % 100 != 0) || (iYear % 400 == 0))
                    && (iYear > MIN && iYear < year);
            datePerMonth = dm ? 29 : 28;
            break;
        default:
            datePerMonth = 31;
        }
        return (iDate >= 1) && (iDate <= datePerMonth);
    }

}
